#include "Body.h"

/**
 * @brief Render the body's meshes with the given shader.
 * @param shader The shader to render the body's mesh with.
 */
void Body::render( Shader &shader )
{
    shader.bind();

    // Transform all vertices to world space based on the current
    // model to world matrix.
    shader.setUniform( "model", m_modelToWorld );

    for (auto mesh : m_meshes)
        mesh->render(shader);
}