#pragma once

#include "Scene.h"
#include "Shader.h"
#include "Triangle.h"

#include <glad/glad.h>
#include <GLFW/glfw3.h>
#include <glm/gtx/transform.hpp>
#include <glm/gtx/orthonormalize.hpp>
#define _USE_MATH_DEFINES
#include <math.h>


class Body;

enum CameraMode {
    BirdsEye = 0,
    Trackball = 1,
    Shooting = 2
};

/**
 * @brief Defines a Camera in a 3D scene.
 */
class Camera
{
public:

    /** Trackball radius, that is used to place the camera during mouse control. */
    float m_radius = 15;

    CameraMode m_cameraMode = CameraMode::Trackball;
    glm::mat4 getViewMatrix( std::shared_ptr<Body> ball, float theta, float phi );


private:
    glm::mat4 birdsEyeView();
    glm::mat4 freeLookView( float phi, float theta );
    glm::mat4 shootingView( std::shared_ptr<Body> whiteball, float phi, float theta );

};